<?php
class ControllerExtensionModuleFeaturedcarusel extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/featuredcarusel');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/module');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (!isset($this->request->get['module_id'])) {
				$this->model_setting_module->addModule('featuredcarusel', $this->request->post);
			} else {
				$this->model_setting_module->editModule($this->request->get['module_id'], $this->request->post);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'], true));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_product'] = $this->language->get('entry_product');
		$data['entry_limit'] = $this->language->get('entry_limit');
		$data['entry_items'] = $this->language->get('entry_items');
		$data['entry_width'] = $this->language->get('entry_width');
		$data['entry_height'] = $this->language->get('entry_height');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['text_class'] = $this->language->get('text_class');
	
		$data['entry_displaytitle'] = $this->language->get('entry_displaytitle');
		$data['help_product'] = $this->language->get('help_product');
$data['entry_prodview'] = $this->language->get('entry_prodview');
$data['text_nodesc'] = $this->language->get('text_nodesc');
$data['text_nodeskmore'] = $this->language->get('text_nodeskmore');
$data['text_deskmore'] = $this->language->get('text_deskmore');
$data['text_pstandart'] = $this->language->get('text_pstandart');

$data['tab_product'] = $this->language->get('tab_product');
$data['tab_category'] = $this->language->get('tab_category');
$data['entry_display'] = $this->language->get('entry_display');

		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset($this->error['width'])) {
			$data['error_width'] = $this->error['width'];
		} else {
			$data['error_width'] = '';
		}

		if (isset($this->error['height'])) {
			$data['error_height'] = $this->error['height'];
		} else {
			$data['error_height'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_module'),
			'href' => $this->url->link('extension/module', 'user_token=' . $this->session->data['user_token'], true)
		);

		if (!isset($this->request->get['module_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('module/featuredcarusel', 'user_token=' . $this->session->data['user_token'], true)
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('module/featuredcarusel', 'user_token=' . $this->session->data['user_token'] . '&module_id=' . $this->request->get['module_id'], 'SSL')
			);
		}

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('extension/module/featuredcarusel', 'user_token=' . $this->session->data['user_token'], true);
		} else {
			$data['action'] = $this->url->link('extension/module/featuredcarusel', 'user_token=' . $this->session->data['user_token'] . '&module_id=' . $this->request->get['module_id'], 'SSL');
		}

		$data['cancel'] = $this->url->link('extension/module', 'user_token=' . $this->session->data['user_token'], true);

		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_setting_module->getModule($this->request->get['module_id']);
		}
		$data['user_token'] = $this->session->data['user_token'];

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}


		if (isset($this->request->post['tab'])) {
			$data['tab'] = $this->request->post['tab'][0];
		} elseif (!empty($module_info['tab'])) {
			$data['tab'] = $module_info['tab'][0];
		} else {
			$data['tab'] = '1';
		}
		if (isset($this->request->post['category']) && $data['tab'] == 2) {
			$data['cur_category'] = $this->request->post['category'];
		} elseif (!empty($module_info['category'])) {
			$data['cur_category'] = $module_info['category'];
		} else {
			$data['cur_category'] = '';
		}

		$this->load->model('catalog/product');

		$data['products'] = array();
		$products = array();
		if (isset($this->request->post['product']) && $data['tab'] == 1) {
			$products = $this->request->post['product'];
		} elseif (!empty($module_info['product'])) {
			$products = $module_info['product'];
		} else {
			$products = array();
		}
		if ($products) {
			foreach ($products as $product_id) {
			$product_info = $this->model_catalog_product->getProduct($product_id);

			if ($product_info) {
				$data['products'][] = array(
					'product_id' => $product_info['product_id'],
					'name'       => $product_info['name']
				);
			}
			}
		}
		$this->load->model('catalog/category');

		$data['scategories'] = array();
		$scategories = array();
		if (isset($this->request->post['scategory'])) {
			$scategories = $this->request->post['scategory'];
		} elseif (!empty($module_info['scategory'])) {
			$scategories = $module_info['scategory'];
		} else {
			$scategories = array();
		}
		if ($scategories) {
			foreach ($scategories as $category_id) {
			$category_info = $this->model_catalog_category->getCategory($category_id);

			if ($category_info) {
				$data['scategories'][] = array(
					'category_id' => $category_info['category_id'],
					'name'       => $category_info['name']
				);
			}
			}
		}


		$data['categories'] = array();
		
		$filter_data = array(
      		'sort'  => 'name',
      		'order' => 'ASC',
		);
		$data['categories'] = $this->model_catalog_category->getCategories($filter_data);

		if (isset($this->request->post['limit'])) {
			$data['limit'] = $this->request->post['limit'];
		} elseif (!empty($module_info)) {
			$data['limit'] = $module_info['limit'];
		} else {
			$data['limit'] = 10;
		}
		if (isset($this->request->post['items'])) {
			$data['items'] = $this->request->post['items'];
		} elseif (!empty($module_info)) {
			$data['items'] = $module_info['items'];
		} else {
			$data['items'] = 4;
		}

		if (isset($this->request->post['class'])) {
			$data['class'] = $this->request->post['class'];
		} elseif (!empty($module_info)) {
			$data['class'] = $module_info['class'];
		} else {
			$data['class'] = '';
		}

		if (isset($this->request->post['width'])) {
			$data['width'] = $this->request->post['width'];
		} elseif (!empty($module_info)) {
			$data['width'] = $module_info['width'];
		} else {
			$data['width'] = 200;
		}

		if (isset($this->request->post['height'])) {
			$data['height'] = $this->request->post['height'];
		} elseif (!empty($module_info)) {
			$data['height'] = $module_info['height'];
		} else {
			$data['height'] = 200;
		}

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}


		if (isset($this->request->post['prodview'])) {
			$data['prodview'] = $this->request->post['prodview'];
		} elseif (!empty($module_info)) {
			$data['prodview'] = $module_info['prodview'];
		} else {
			$data['prodview'] = '0';
		}

		if (isset($this->request->post['displaytitle'])) {
			$data['displaytitle'] = $this->request->post['displaytitle'];
		} elseif (!empty($module_info)) {
			$data['displaytitle'] = $module_info['displaytitle'];
		} else {
			$data['displaytitle'] = '';
		}

		
		

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/featuredcarusel', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/featuredcarusel')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 64)) {
			$this->error['name'] = $this->language->get('error_name');
		}

		if (!$this->request->post['width']) {
			$this->error['width'] = $this->language->get('error_width');
		}

		if (!$this->request->post['height']) {
			$this->error['height'] = $this->language->get('error_height');
		}

		return !$this->error;
	}
}